//-----------------------------------------------------------------------------
// [xl`悷
//-----------------------------------------------------------------------------

struct VS_OUTPUT
{
	float4 Pos			: POSITION; 		// ˉeϊW
	float4 ShadowMapTex	: TEXCOORD0;		// Zobt@eNX`
};



// _VF[_
VS_OUTPUT ZBufferCalc_VS( float4 Pos : POSITION )
{
	VS_OUTPUT Out;
	Out.ShadowMapTex = Out.Pos = mul( Pos, matWVP );
	return Out;
}



// sNZVF[_
// [xlo
float4 ZBufferPlot_PS( float4 ShadowMapTex : TEXCOORD0 ) : COLOR
{
	return float4( ShadowMapTex.z / ShadowMapTex.w, 1.0f, 1.0f, 1.0f );
}



// [xlƐ[xl̓o VSMp
float4 ZBufferPlotForVSM_PS( float4 ShadowMapTex : TEXCOORD0 ) : COLOR
{
	float z = ShadowMapTex.z / ShadowMapTex.w;
	return float4( z, z*z, 1.0f, 1.0f );
}



// eNjbN
technique DepthPlot
{
	pass P0
	{
		VertexShader = compile vs_2_0 ZBufferCalc_VS();
		PixelShader = compile ps_2_0 ZBufferPlot_PS();
		CullMode = faceRight;
		ColorWriteEnable = RED;
	}
}



technique DepthPlotForVSM
{
	pass P0
	{
		VertexShader = compile vs_2_0 ZBufferCalc_VS();
		PixelShader = compile ps_2_0 ZBufferPlotForVSM_PS();
		CullMode = faceRight;
		ColorWriteEnable = RED|GREEN;
	}
}


